/*
Scrivere un programma per la gestione dei dipendenti e delle loro attivit.
I dipendenti sono caratterizzati da: cognome, nome, matricola e tipo di qualifica (0..4).
Le attivit sono caratterizzate da: matricola dipendente, data, codice attivit (0..9). 
I dipendenti sono inseriti in un vettore di 5 liste,  una per ogni tipo di qualifica. 
Le attivit sono inserite in una tabella allocata dinamicamente avente 10 righe, una  per ogni codice attivit.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento  nel vettore di liste di un nuovo dipendente; 
2.	Ricerca di un dipendente ( chiedere matricola e tipo di qualifica);
3.	Inserimento di una nuova attivit;
4.	Eliminazione di un'attivit dopo averla visualizzata (chiedere la matricola e il codice attivit);
5.	Salvataggio su file delle attivit;

All'avvio del programma inizializzare la tabella delle attivit leggendo da file le attivit precedentemente salvate.

Liberare la memoria allocata dinamicamente.

*/

#include <stdio.h>
#include <stdlib.h>

struct dipendente {
       char cognome[30];
       char nome[30];
       int matricola;
       int tipo;
       };
       
struct atomo {
       struct dipendente dato;
       struct atomo *next;
       };
       
struct attivita {
       int matricola;
       char data[20];
       int codice;
       };
       

void ins_dip(struct atomo *L[5]);
void ricerca_dip(struct atomo *L[5]);
void ins_att(struct attivita *T[10], int *N);
void elimina_att(struct attivita *T[10], int *N);
void salva_att(struct attivita *T[10], int *N);
void inizializza_tab(struct attivita *T[10], int *N);

main()
{
      struct atomo *L[5];
      struct atomo *aux;
      struct attivita *T[10];
      int i, scelta, N[10];
      
      for(i=0;i<10;i++)
        {
           T[i]=NULL;
           N[i]=0;
        }
        
      for(i=0;i<5;i++)
         L[i]=NULL;
      
      inizializza_tab(T,N);
      
      do {
          printf("\nProgramma per la gestione dei dipendenti e delle loro attivita'\n");
          printf("\n       ---MENU'---   \n");
          printf("1) Inserisci un nuovo dipendente\n");
          printf("2) Ricerca dipendente\n");
          printf("3) Inserisci una nuova attivita'\n");
          printf("4) Elimina attivita'\n");
          printf("5) Salva su file le attivita'\n");
          printf("0) Termina esecuzione\n\n");
          scanf("%d",&scelta);
          switch(scelta) {
                         case 1:   ins_dip(L);
                                   break;
                         case 2:   ricerca_dip(L);
                                   break;
                         case 3:   ins_att(T,N);
                                   break;
                         case 4:   elimina_att(T,N);
                                   break;
                         case 5:   salva_att(T,N);
                                   break;
                         default:  printf("Tasto errato\n\n"); }
          
          }  while(scelta!=0);
          
          for(i=0;i<10;i++)
             free(T[i]);
             
          for(i=0;i<5;i++)
             while(L[i]!=NULL)
               {
                  aux=L[i];
                  L[i]=aux->next;
                  free(aux);
               }
               
}



void ins_dip(struct atomo *L[5])
{
     struct atomo *aux;
     struct dipendente d;
     int tipo;
     /* legge dipendente*/
     printf("- Cognome: ");
     scanf("%s",d.cognome);
     printf("- Nome: ");
     scanf("%s",d.nome);
     printf("- Matricola: ");
     scanf("%d",&d.matricola);
     printf("- Tipo qualifica (0...4): ");
     scanf("%d",&d.tipo);
     
    /* inserisce dipendente in testa*/ 
     aux=malloc(sizeof(struct atomo));
     if(aux==NULL)
       {
         printf("Memoria non allocata!\n");
         return;
       }
     
     tipo=d.tipo;
     aux->dato=d;
     aux->next=L[tipo];
     L[tipo]=aux;
}

void ricerca_dip(struct atomo *L[5])
{
     int tipo, matricola;
     struct atomo *aux;
     
     printf("- Inserisci tipo di qualifica (0...4): ");
     scanf("%d",&tipo);

           if(L[tipo]==NULL) /* lista vuota*/
              {
                printf("Nessun dipendente con questo tipo di qualifica\n");
                return;
              }
              
           printf("- Matricola dipendente: ");
           scanf("%d",&matricola);
           aux=L[tipo];
           while(aux!=NULL)
              if(matricola==aux->dato.matricola) /* trovato */
                 {
                    printf("- Cognome: %s\n",aux->dato.cognome);
                    printf("- Nome: %s\n",aux->dato.nome);
                    return;
                 }
              else aux=aux->next;
              
           /* se si esce dal ciclo while perche' aux==NULL vuol dire che non e'
              stato trovato*/   
           printf("Non trovato!\n");
}
     

void ins_att(struct attivita *T[10], int *N)
{
     
     struct attivita *aux;
     struct attivita a;
     int codice;
     
     /* legge attivita' */
     printf("- Matricola dipendente: ");
     scanf("%d",&a.matricola);
     printf("- Data: ");
     scanf("%s",a.data);
     printf("- Codice attivita' (0...9): ");
     scanf("%d",&a.codice);
     
     /* inserisce attivita' in ultima posizione */
     codice=a.codice;
     aux=realloc(T[codice],sizeof(struct attivita)*(N[codice]+1));
     if(aux==NULL)
       {
          printf("Memoria non allocata\n");
          return;
       }
     T[codice]=aux;
     T[codice][N[codice]]=a;
     N[codice]++;
     
}
     

void elimina_att(struct attivita *T[10], int *N)
{
     int i, j, matricola, codice;
     
     printf("- Inserisci codice attivita' (0...9): ");
     scanf("%d",&codice);
     printf("- Inserisci matricola dipendente: ");
     scanf("%d",&matricola);
     
     for(i=0;i<N[codice];i++)
        if(T[codice][i].matricola==matricola)
            break; /* trovato */
            
     if(i==N[codice]) /* non e' stato trovato */
        {  printf("L'attivita' del dipendente non e' stata trovata\n");
           return;
        }
     else       
     /* visualizza l'elemento da eliminare */
     printf("L'attivita' eliminata e' quella relativa alla seguente data: %s\n", T[codice][i].data);
     
     /* elimina l'elemento in posizione i*/
     for(j=i;j<N[codice]-1;j++)
        T[codice][j]=T[codice][j-1];
     N[codice]--;
     T[codice]=realloc(T[codice],sizeof(struct attivita)*(N[codice]));

}


void salva_att(struct attivita *T[10], int *N)
{
     int i;
     FILE *pf;
     pf=fopen("attivita.txt","w");
     if(pf)
       {
          for(i=0;i<10;i++)
             fwrite(T[i], sizeof(struct attivita), N[i],pf);
          fclose(pf);
       }
       
}


void inizializza_tab(struct attivita *T[10], int *N)
{
     int codice;
     struct attivita a;
     struct attivita *aux;
     FILE *pf;
     
     pf=fopen("attivita.txt","r");
     if(pf)
       {  
           while(fread(&a,sizeof(struct attivita),1,pf))
           {
              codice=a.codice;
              aux=realloc(T[codice],sizeof(struct attivita)*(N[codice]+1));
              
              if(aux==NULL)
                 return;
              T[codice]=aux;
              T[codice][N[codice]]=a;
              N[codice]++;
              
           }
          fclose(pf);
       } 
     else printf("\n           Il file non e' ancora stato creato\n");
     
}




    


      
