/*
Scrivere un programma per la gestione degli libri di una biblioteca comunale e dei loro prestiti. 
I libri sono caratterizzati da: Titolo, Autore, collocazione, genere (0..3).
I prestiti sono caratterizzati da: codice fiscale, codice prestito, data prestito(aaaa/gg/mm), categoria (0=studenti, 1=lavoratori, 2= altro).
I libri sono inseriti in una tabella allocata dinamicamente avente 4 righe, una per ogni  genere.
I prestiti sono inseriti in un vettore di 3 liste, una per ogni categoria. 


Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.	Inserimento di una nuovo libro;
2.	Ricerca di un libro (chiedere il genere e il titolo);
3.	Inserimento  nel vettore di liste di un nuovo prestito; 
4.	Eliminazione di un prestito dopo la sua visualizzazione (chiedere categoria e codice prestito);
5.	Salvataggio su file dei libri;

All'avvio del programma inizializzare la tabella dei libri leggendo da file i libri  precedentemente salvati.

Al termine dell'esecuzione del programma liberare la memoria allocata dinamicamente


*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct libro{
       char titolo[30],autore[20];
       int collocazione,genere;
       };
       
struct prestito{
       char codfisc[17];
       int categoria,codice,data;
       };
struct atomo{
       struct prestito dato;
       struct atomo *next;
       };
       
void ins_libro(struct libro *T[4],int N[4],struct libro l)
{
 	 struct libro *aux;
 	 int i;
 	 
 	 i=l.genere;
 	 aux=realloc(T[i],sizeof(struct libro)*(N[i]+1));
 	 if(aux)
 	   {T[i]=aux;
 	    T[i][N[i]]=l;
 	    N[i]++;
      }
     else printf("Memoria non allocata");
}

void ricerca(struct libro *T[4],int N[4])
{    char titolo[30];
     int gen,j;
     
     printf("Genere: ");
     scanf("%d",&gen);
     printf("Titolo: ");
     scanf("%s",titolo);
  
     for(j=0;j<N[gen];j++)
        if(strcmp(titolo,T[gen][j].titolo)==0)
                {printf("Trovato\n");
                 printf("Autore libro: %s\n",T[gen][j].autore);
                 printf("Collocazione libro: %d\n",T[gen][j].collocazione);
                 return;
                }
     /* se si e' giunti in questo punto 
        vuol dire che il libro non e' stato trovato*/           
     printf("Non trovato");
}

void in_testa(struct atomo *L[3],struct prestito p)
{
 	 struct atomo *aux;
 	 int i;
 	 
 	 i=p.categoria;
 	 aux=malloc(sizeof(struct atomo));
 	 if(aux)
       {aux->dato=p;
        aux->next=L[i];
        L[i]=aux;
       }
}

void elimina(struct atomo *L[3])
{
 	 struct atomo *l1,*l2;
 	 int i,p;
 	 
 	 printf("Categoria: ");
 	 scanf("%d",&i);
 	 printf("Codice prestito: ");
 	 scanf("%d",&p);
 	 
 	 if(L[i]==NULL)
 	   {printf("Lista vuota");
 	    return;
		}
		
     if(p==L[i]->dato.codice)    // da testa
       {l1=L[i];
        
        /* visualizza elemento da eliminare */
        printf("Codice fiscale: %s",l1->dato.codfisc);
        printf("\nData prestito: %d",l1->dato.data);
        /* elimina */
        L[i]=l1->next;
        free(l1);
		return;
       }
       
     l2=L[i];
     l1=l2->next;
     while(l1!=NULL)
          if(p==l1->dato.codice)
            {
              /* visualizza elemento da eliminare */
             printf("Codice fiscale: %s",l1->dato.codfisc);
             printf("\nData prestito: %d",l1->dato.data);
             /* elimina */
             l2->next=l1->next;
             free(l1);
			 return;
            }
			else {l1=l1->next;
			      l2=l2->next;
                 }
    printf("Non trovato");
}

void salva(struct libro *T[3],int N[3])
{
 	 FILE *pf;
 	 int i,g;
     
     
     pf=fopen("libri.txt","w");
     if(pf)
       {for(i=0;i<3;i++)
            for(g=0;g<N[i];g++)
                fwrite(&T[i][g],sizeof(struct libro),1,pf);
        fclose(pf);
       }
     else printf("Errore in scrittura file");
}

void inizializza(struct libro *T[3],int N[3])
{
 	 FILE *pf;
 	 struct libro l;
 	
 	 
 	 pf=fopen("libri.txt","r");
 	 if(pf)
 	   {while(fread(&l,sizeof(struct libro),1,pf))
 	          ins_libro(T,N,l);
        fclose(pf);
       }
        
	 else printf("Errore in lettura");
}

main(){
       struct atomo *L[3],*aux;
       struct libro *T[4],l;
       struct prestito p;
       int i,scelta,N[4];
       
       //inizializzazione
       for(i=0;i<4;i++)
          {T[i]=NULL;
           N[i]=0;}
       for(i=0;i<3;i++)
           L[i]=NULL;
           
       inizializza(T,N);
       do{
           printf("\n---MENU---\n");
           printf("Scegli tra:\n1)Inserimento di un libro\n2)Ricerca libro\n");
           printf("3)Inserimento prestito \n4)Eliminazione prestito con visualizzazione\n");
           printf("5)Salva libri \n0)Fine\n");
           scanf("%d",&scelta);
           switch(scelta){
                          case 1:printf("DATI LIBRO:\n");
                                 printf("Titolo: ");
                                 scanf("%s",l.titolo);
                                 printf("Autore: ");
                                 scanf("%s",l.autore);
                                 printf("Collocazione: ");
                                 scanf("%d",&l.collocazione);
                                 printf("Genere libro: ");
                                 scanf("%d",&l.genere);
                                 ins_libro(T,N,l);
                                 break;
                          case 2:ricerca(T,N);
                                 break;
                          case 3:printf("NUOVO PRESTITO\n");
                                 printf("Codice fiscale del richiedente: ");
                                 scanf("%s",p.codfisc);
                                 printf("Codice prestito: ");
                                 scanf("%d",&p.codice);
                                 printf("Data del prestito(aaaa/gg/mm): ");
                                 scanf("%d",&p.data);
                                 printf("Categoria prestito(0=studente;1=lavoratore;2=altro): ");
                                 scanf("%d",&p.categoria);
                                 in_testa(L,p);
                                 break;
                          case 4:elimina(L);
                                 break;
                          case 5:salva(T,N);
                                 break;
                          default:;
                          }
           }while(scelta!=0);
                          
      //liberazione memoria
       for(i=0;i<4;i++)
          free(T[i]);
       for(i=0;i<3;i++)
          while(L[i]!=NULL)
               {aux=L[i];
                L[i]=aux->next;
                free(aux);
               }
                 
}
